Index: runtime/cmake/modules/FindPackageVersionCheck.cmake
===================================================================
--- runtime/cmake/modules/FindPackageVersionCheck.cmake	(revision 0)
+++ runtime/cmake/modules/FindPackageVersionCheck.cmake	(revision 0)
@@ -0,0 +1,68 @@
+# FIND_PACKAGE_VERSION_CHECK(NAME (DEFAULT_MSG|"Custom failure message"))
+#    This function is intended to be used in FindXXX.cmake modules files.
+#    It handles NAME_FIND_VERSION and NAME_VERSION variables in a Module.
+#
+#    Example:
+#    find_package(LibSSH 0.3.2)
+#
+#    # check for the version and set it
+#    set(LibSSH_VERSION 0.3.0)
+#    find_package_version_check(LibSSH DEFAULT_MSG)
+#
+#
+# Copyright (c) 2009 Andreas Schneider <mail@cynapses.org>
+#
+# Redistribution and use is allowed according to the terms of the New
+# BSD license.
+
+function(FIND_PACKAGE_VERSION_CHECK _NAME _FAIL_MSG)
+  string(TOUPPER ${_NAME} _NAME_UPPER)
+  set(_AGE "old")
+
+  if(${_NAME}_FIND_VERSION_EXACT)
+    if (${_NAME}_FIND_VERSION VERSION_EQUAL ${_NAME}_VERSION)
+      # exact version found
+      set(${_NAME_UPPER}_FOUND TRUE)
+    else (${_NAME}_FIND_VERSION VERSION_EQUAL ${_NAME}_VERSION)
+      # exect version not found
+      set(${_NAME_UPPER}_FOUND FALSE)
+      # check if newer or older
+      if (${_NAME}_FIND_VERSION VERSION_LESS ${_NAME}_VERSION)
+        set(_AGE "new")
+      else (${_NAME}_FIND_VERSION VERSION_LESS ${_NAME}_VERSION)
+        set(_AGE "old")
+      endif (${_NAME}_FIND_VERSION VERSION_LESS ${_NAME}_VERSION)
+    endif (${_NAME}_FIND_VERSION VERSION_EQUAL ${_NAME}_VERSION)
+  else (${_NAME}_FIND_VERSION_EXACT)
+    if (${_NAME}_FIND_VERSION)
+      if (${_NAME}_VERSION VERSION_LESS ${_NAME}_FIND_VERSION)
+        set(${_NAME_UPPER}_FOUND FALSE)
+        set(_AGE "old")
+      else (${_NAME}_VERSION VERSION_LESS ${_NAME}_FIND_VERSION)
+        set(${_NAME_UPPER}_FOUND TRUE)
+     endif (${_NAME}_VERSION VERSION_LESS ${_NAME}_FIND_VERSION)
+    endif (${_NAME}_FIND_VERSION)
+  endif(${_NAME}_FIND_VERSION_EXACT)
+
+  if ("${_FAIL_MSG}" STREQUAL "DEFAULT_MSG")
+    if (${_NAME}_FIND_VERSION_EXACT)
+      set(_FAIL_MESSAGE "The installed ${_NAME} version ${${_NAME}_VERSION} is too ${_AGE}, version ${${_NAME}_FIND_VERSION} is required.")
+    else (${_NAME}_FIND_VERSION_EXACT)
+      set(_FAIL_MESSAGE "The installed ${_NAME} version ${${_NAME}_VERSION} is too ${_AGE}, at least version ${${_NAME}_FIND_VERSION} is required.")
+    endif (${_NAME}_FIND_VERSION_EXACT)
+  else ("${_FAIL_MSG}" STREQUAL "DEFAULT_MSG")
+    set(_FAIL_MESSAGE "${_FAIL_MSG}")
+  endif ("${_FAIL_MSG}" STREQUAL "DEFAULT_MSG")
+
+  if (NOT ${_NAME_UPPER}_FOUND)
+    if (${_NAME}_FIND_REQUIRED)
+      message(FATAL_ERROR "${_FAIL_MESSAGE}")
+    else (${_NAME}_FIND_REQUIRED)
+      if (NOT ${_NAME}_FIND_QUIETLY)
+        message(STATUS "${_FAIL_MESSAGE}")
+      endif (NOT ${_NAME}_FIND_QUIETLY)
+    endif (${_NAME}_FIND_REQUIRED)
+  endif (NOT ${_NAME_UPPER}_FOUND)
+
+  set(${_NAME_UPPER}_FOUND ${${_NAME_UPPER}_FOUND} PARENT_SCOPE)
+endfunction(FIND_PACKAGE_VERSION_CHECK)
Index: runtime/cmake/modules/FindLibSSH.cmake
===================================================================
--- runtime/cmake/modules/FindLibSSH.cmake	(revision 0)
+++ runtime/cmake/modules/FindLibSSH.cmake	(revision 0)
@@ -0,0 +1,92 @@
+# - Try to find LibSSH
+# Once done this will define
+#
+#  LIBSSH_FOUND - system has LibSSH
+#  LIBSSH_INCLUDE_DIRS - the LibSSH include directory
+#  LIBSSH_LIBRARIES - Link these to use LibSSH
+#  LIBSSH_DEFINITIONS - Compiler switches required for using LibSSH
+#
+#  Copyright (c) 2009 Andreas Schneider <mail@cynapses.org>
+#
+#  Redistribution and use is allowed according to the terms of the New
+#  BSD license.
+#  For details see the accompanying COPYING-CMAKE-SCRIPTS file.
+#
+
+if (LIBSSH_LIBRARIES AND LIBSSH_INCLUDE_DIRS)
+  # in cache already
+  set(LIBSSH_FOUND TRUE)
+else (LIBSSH_LIBRARIES AND LIBSSH_INCLUDE_DIRS)
+
+  find_path(LIBSSH_INCLUDE_DIR
+    NAMES
+      libssh/libssh.h
+    PATHS
+      /usr/include
+      /usr/local/include
+      /opt/local/include
+      /sw/include
+  )
+
+  find_library(SSH_LIBRARY
+    NAMES
+      ssh
+      libssh
+    PATHS
+      /usr/lib
+      /usr/local/lib
+      /opt/local/lib
+      /sw/lib
+  )
+
+  if (LIBSSH_INCLUDE_DIR AND SSH_LIBRARY)
+    set(SSH_FOUND TRUE)
+  endif (LIBSSH_INCLUDE_DIR AND SSH_LIBRARY)
+
+  set(LIBSSH_INCLUDE_DIRS
+    ${LIBSSH_INCLUDE_DIR}
+  )
+
+  if (SSH_FOUND)
+    set(LIBSSH_LIBRARIES
+      ${LIBSSH_LIBRARIES}
+      ${SSH_LIBRARY}
+    )
+
+    if (LibSSH_FIND_VERSION)
+      file(STRINGS ${LIBSSH_INCLUDE_DIR}/libssh/libssh.h LIBSSH_VERSION_MAJOR
+        REGEX "#define[ ]+LIBSSH_VERSION_MAJOR[ ]+[0-9]+")
+      # Older versions of libssh like libssh-0.2 have LIBSSH_VERSION but not LIBSSH_VERSION_MAJOR
+      if (LIBSSH_VERSION_MAJOR)
+        string(REGEX MATCH "[0-9]+" LIBSSH_VERSION_MAJOR ${LIBSSH_VERSION_MAJOR})
+	file(STRINGS ${LIBSSH_INCLUDE_DIR}/libssh/libssh.h LIBSSH_VERSION_MINOR
+          REGEX "#define[ ]+LIBSSH_VERSION_MINOR[ ]+[0-9]+")
+	string(REGEX MATCH "[0-9]+" LIBSSH_VERSION_MINOR ${LIBSSH_VERSION_MINOR})
+	file(STRINGS ${LIBSSH_INCLUDE_DIR}/libssh/libssh.h LIBSSH_VERSION_PATCH
+          REGEX "#define[ ]+LIBSSH_VERSION_MICRO[ ]+[0-9]+")
+	string(REGEX MATCH "[0-9]+" LIBSSH_VERSION_PATCH ${LIBSSH_VERSION_PATCH})
+
+	set(LibSSH_VERSION ${LIBSSH_VERSION_MAJOR}.${LIBSSH_VERSION_MINOR}.${LIBSSH_VERSION_PATCH})
+
+	include(FindPackageVersionCheck)
+	find_package_version_check(LibSSH DEFAULT_MSG)
+      else (LIBSSH_VERSION_MAJOR)
+        message(STATUS "LIBSSH_VERSION_MAJOR not found in ${LIBSSH_INCLUDE_DIR}/libssh/libssh.h, assuming libssh is too old")
+        set(LIBSSH_FOUND FALSE)
+      endif (LIBSSH_VERSION_MAJOR)
+    endif (LibSSH_FIND_VERSION)
+  endif (SSH_FOUND)
+
+  # If the version is too old, but libs and includes are set,
+  # find_package_handle_standard_args will set LIBSSH_FOUND to TRUE again,
+  # so we need this if() here.
+  if (LIBSSH_FOUND)
+    include(FindPackageHandleStandardArgs)
+    find_package_handle_standard_args(LibSSH DEFAULT_MSG LIBSSH_LIBRARIES LIBSSH_INCLUDE_DIRS)
+  endif (LIBSSH_FOUND)
+
+  # show the LIBSSH_INCLUDE_DIRS and LIBSSH_LIBRARIES variables only in the advanced view
+  mark_as_advanced(LIBSSH_INCLUDE_DIRS LIBSSH_LIBRARIES)
+
+endif (LIBSSH_LIBRARIES AND LIBSSH_INCLUDE_DIRS)
+
Index: runtime/kioslave/sftp/AUTHORS
===================================================================
--- runtime/kioslave/sftp/AUTHORS	(revision 1026868)
+++ runtime/kioslave/sftp/AUTHORS	(working copy)
@@ -1,3 +1,3 @@
+Andreas Schneider <mail@cynapses.org>
 Dawit Alemayehu <adawit@kde.org>
 Lucas Fisher <ljfisher@iastate.edu>
-
Index: runtime/kioslave/sftp/CHANGELOG
===================================================================
--- runtime/kioslave/sftp/CHANGELOG	(revision 1026868)
+++ runtime/kioslave/sftp/CHANGELOG	(working copy)
@@ -1,3 +1,8 @@
+2009-08-01 - Rewrite with libssh.
+             * Resume support
+             * Support for different details
+             * Mimetype support
+
 - add dialog to ask for username
 - rename() causes SSH to die
 - How to handle overwrite?
Index: runtime/kioslave/sftp/kio_sftp.cpp
===================================================================
--- runtime/kioslave/sftp/kio_sftp.cpp	(revision 1026868)
+++ runtime/kioslave/sftp/kio_sftp.cpp	(working copy)
@@ -1,27 +1,23 @@
-/***************************************************************************
-                          sftp.cpp  -  description
-                             -------------------
-    begin                : Fri Jun 29 23:45:40 CDT 2001
-    copyright            : (C) 2001 by Lucas Fisher
-    email                : ljfisher@purdue.edu
- ***************************************************************************/
-
-/***************************************************************************
- *                                                                         *
- *   This program is free software; you can redistribute it and/or modify  *
- *   it under the terms of the GNU General Public License as published by  *
- *   the Free Software Foundation; either version 2 of the License, or     *
- *   (at your option) any later version.                                   *
- *                                                                         *
- ***************************************************************************/
-
 /*
-DEBUGGING
-We are pretty much left with kDebug messages for debugging. We can't use a gdb
-as described in the ioslave DEBUG.howto because kdeinit has to run in a terminal.
-Ssh will detect this terminal and ask for a password there, but will just get garbage.
-So we can't connect.
-*/
+ * Copyright (c) 2001      Lucas Fisher <ljfisher@purdue.edu>
+ * Copyright (c) 2009      Andreas Schneider <mail@cynapses.org>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License (LGPL) as published by the Free Software Foundation;
+ * either version 2 of the License, or (at your option) any later
+ * version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
 
 #include "kio_sftp.h"
 
@@ -32,25 +28,21 @@
 #include <QtCore/QCoreApplication>
 #include <QtCore/QBuffer>
 #include <QtCore/QByteArray>
+#include <QtCore/QDir>
 #include <QtCore/QFile>
 #include <QtCore/QObject>
 #include <QtCore/QString>
+#include <QtCore/QVarLengthArray>
 
 #include <stdlib.h>
 #include <unistd.h>
-#include <signal.h>
 #include <errno.h>
-#include <ctype.h>
 #include <time.h>
-#include <netdb.h>
 #include <string.h>
 
-#include <netinet/in.h>
-#include <arpa/inet.h>
 #include <sys/time.h>
 #include <sys/stat.h>
 #include <sys/types.h>
-#include <sys/wait.h>
 
 #include <kapplication.h>
 #include <kuser.h>
@@ -64,15 +56,11 @@
 #include <kio/ioslave_defaults.h>
 #include <kmimetype.h>
 #include <kde_file.h>
-#include <kremoteencoding.h>
 #include <kconfiggroup.h>
 
-#include "sftp.h"
-#include "atomicio.h"
-#include "sftpfileattr.h"
-#include "ksshprocess.h"
+#include <libssh/libssh.h>
+#include <libssh/sftp.h>
 
-
 using namespace KIO;
 extern "C"
 {
Index: runtime/kioslave/sftp/kio_sftp.h
===================================================================
--- runtime/kioslave/sftp/kio_sftp.h	(revision 1026868)
+++ runtime/kioslave/sftp/kio_sftp.h	(working copy)
@@ -1,36 +1,43 @@
-/***************************************************************************
-                          sftpProtocol.h  -  description
-                             -------------------
-    begin                : Sat Jun 30 20:08:47 CDT 2001
-    copyright            : (C) 2001 by Lucas Fisher
-    email                : ljfisher@purdue.edu
-***************************************************************************/
+/*
+ * Copyright (c) 2001      Lucas Fisher <ljfisher@purdue.edu>
+ * Copyright (c) 2009      Andreas Schneider <mail@cynapses.org>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License (LGPL) as published by the Free Software Foundation;
+ * either version 2 of the License, or (at your option) any later
+ * version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
 
-/***************************************************************************
- *                                                                         *
- *   This program is free software; you can redistribute it and/or modify  *
- *   it under the terms of the GNU General Public License as published by  *
- *   the Free Software Foundation; either version 2 of the License, or     *
- *   (at your option) any later version.                                   *
- *                                                                         *
- ***************************************************************************/
 #ifndef __kio_sftp_h__
 #define __kio_sftp_h__
 
-
-#include <QObject>
-
 #include <kurl.h>
 #include <kio/global.h>
 #include <kio/slavebase.h>
 #include <kdebug.h>
 
-#include "process.h"
-#include "sftpfileattr.h"
-#include "ksshprocess.h"
+#include <libssh/libssh.h>
+#include <libssh/sftp.h>
 
+// How big should each data packet be? Definitely not bigger than 64kb or
+// you will overflow the 2 byte size variable in a sftp packet.
+#define MAX_XFER_BUF_SIZE 60 * 1024
 #define KIO_SFTP_DB 7120
 
+namespace KIO {
+  class AuthInfo;
+}
 
 class sftpProtocol : public KIO::SlaveBase
 {
@@ -38,20 +45,20 @@
 public:
   sftpProtocol(const QByteArray &pool_socket, const QByteArray &app_socket);
   virtual ~sftpProtocol();
-  virtual void setHost(const QString& h, quint16 port, const QString& user, const QString& pass);
-  virtual void get(const KUrl& url);
-  virtual void listDir(const KUrl& url) ;
-  virtual void mimetype(const KUrl& url);
-  virtual void stat(const KUrl& url);
+  virtual void setHost(const QString &h, quint16 port, const QString& user, const QString& pass);
+  virtual void get(const KUrl &url);
+  virtual void listDir(const KUrl &url) ;
+  virtual void mimetype(const KUrl &url);
+  virtual void stat(const KUrl &url);
   virtual void copy(const KUrl &src, const KUrl &dest, int permissions, KIO::JobFlags flags);
-  virtual void put(const KUrl& url, int permissions, KIO::JobFlags flags);
+  virtual void put(const KUrl &url, int permissions, KIO::JobFlags flags);
   virtual void closeConnection();
   virtual void slave_status();
   virtual void del(const KUrl &url, bool isfile);
-  virtual void chmod(const KUrl& url, int permissions);
-  virtual void symlink(const QString& target, const KUrl& dest, KIO::JobFlags flags);
-  virtual void rename(const KUrl& src, const KUrl& dest, KIO::JobFlags flags);
-  virtual void mkdir(const KUrl&url, int permissions);
+  virtual void chmod(const KUrl &url, int permissions);
+  virtual void symlink(const QString &target, const KUrl &dest, KIO::JobFlags flags);
+  virtual void rename(const KUrl &src, const KUrl &dest, KIO::JobFlags flags);
+  virtual void mkdir(const KUrl &url, int permissions);
   virtual void openConnection();
 
   // KIO::FileJob interface
@@ -61,6 +68,10 @@
   virtual void seek(KIO::filesize_t offset);
   virtual void close();
 
+  // libssh authentication callback (note that this is called by the
+  // global ::auth_callback() call.
+  int auth_callback(const char *prompt, char *buf, size_t len,
+    int echo, int verify, void *userdata);
 private: // Private variables
   /** True if ioslave is connected to sftp server. */
   bool mConnected;
@@ -71,20 +82,23 @@
   /** Port we are connected to. */
   int mPort;
 
-  /** Ssh process to which we send the sftp packets. */
-  KSshProcess ssh;
+  /** The ssh session for the connection */
+  SSH_SESSION *ssh_session;
 
+  /** The sftp session for the connection */
+  SFTP_SESSION *sftp_session;
+
   /** Username to use when connecting */
   QString mUsername;
 
   /** User's password */
   QString mPassword;
 
-  /** Message id of the last sftp packet we sent. */
-  unsigned int mMsgId;
+  /** The open file */
+  SFTP_FILE *mOpenFile;
 
-  /** Type of packet we are expecting to receive next. */
-  unsigned char mExpected;
+  /** The open URL */
+  KUrl mOpenUrl;
 
   /** Version of the sftp protocol we are using. */
   int sftpVersion;
@@ -103,60 +117,15 @@
   KIO::filesize_t openOffset;
 
 private: // private methods
-  bool getPacket(QByteArray& msg);
 
-   /* Type is a sftp packet type found in .sftp.h'.
-   * Example: SSH2_FXP_READLINK, SSH2_FXP_RENAME, etc.
-   *
-   * Returns true if the type is supported by the sftp protocol
-   * version negotiated by the client and server (sftpVersion).
-   */
-  bool isSupportedOperation(int type);
-  /** Used to have the server canonicalize any given path name to an absolute path.
-      This is useful for converting path names containing ".." components or relative
-      pathnames without a leading slash into absolute paths.
-      Returns the canonicalized url. */
-  int sftpRealPath(const KUrl& url, KUrl& newUrl);
+  int authenticateKeyboardInteractive(KIO::AuthInfo &info);
 
-  /** Send an sftp packet to stdin of the ssh process. */
-  bool putPacket(QByteArray& p);
-  /** Process SSH_FXP_STATUS packets. */
-  void processStatus(quint8, const QString& message = QString());
-  /** Process SSH_FXP_STATUS packes and return the result. */
-  Status doProcessStatus(quint8, const QString& message = QString());
-  /** Opens a directory handle for url.path. Returns true if succeeds. */
-  int sftpOpenDirectory(const KUrl& url, QByteArray& handle);
-  /** Closes a directory or file handle. */
-  int sftpClose(const QByteArray& handle);
-  /** Send a sftp command to rename a file or directory. */
-  int sftpRename(const KUrl& src, const KUrl& dest);
-  /** Set a files attributes. */
-  int sftpSetStat(const KUrl& url, const sftpFileAttr& attr);
-  /** Sends a sftp command to remove a file or directory. */
-  int sftpRemove(const KUrl& url, bool isfile);
-  /** Creates a symlink named dest to target. */
-  int sftpSymLink(const QString& target, const KUrl& dest);
-  /** Get directory listings. */
-  int sftpReadDir(const QByteArray& handle, const KUrl& url);
-  /** Retrieves the destination of a link. */
-  int sftpReadLink(const KUrl& url, QString& target);
-  /** Stats a file. */
-  int sftpStat(const KUrl& url, sftpFileAttr& attr);
-  /** No descriptions */
-  int sftpOpen(const KUrl& url, const quint32 pflags, const sftpFileAttr& attr, QByteArray& handle);
-  /** No descriptions */
-  int sftpRead(const QByteArray& handle, KIO::filesize_t offset, quint32 len, QByteArray& data);
-  /** No descriptions */
-  int sftpWrite(const QByteArray& handle, KIO::filesize_t offset, const QByteArray& data);
+  void reportError(const KUrl &url, const int err);
 
-  /** Performs faster upload when the source is a local file... */
-  void sftpCopyPut(const KUrl& src, const KUrl& dest, int mode, KIO::JobFlags flags);
-  /** Performs faster download when the destination is a local file... */
-  void sftpCopyGet(const KUrl& dest, const KUrl& src, int mode, KIO::JobFlags flags);
+  bool createUDSEntry(const QString &filename, const QByteArray &path,
+      KIO::UDSEntry &entry, short int details);
 
-  /** Read a file. This is used by get(), copy(), and mimetype(). */
-  Status sftpGet( const KUrl& src, KIO::filesize_t offset = 0, int fd = -1, bool abortAfterMimeType = false);
-  /** Write a file */
-  void sftpPut( const KUrl& dest, int permissions, KIO::JobFlags flags, int fd = -1);
+  QString canonicalizePath(const QString &path);
 };
+
 #endif
Index: runtime/kioslave/sftp/TODO
===================================================================
--- runtime/kioslave/sftp/TODO	(revision 1026868)
+++ runtime/kioslave/sftp/TODO	(working copy)
@@ -1,51 +1,4 @@
 TODO:
-- Password caching doesn't work. We get a new dialog box every time a new kio_sftp process starts.
-  Very annoying.
-  
-- Support for use of public keys, maybe ssh-agent, a key management app, etc.
-
-- bug: when changing hostname in locationbar, password dialog pops up at
-  every change even without pressing enter
-  - Bug report submitted to konqueror
-
-- bug: kio_sftp crashes KDE completely when one or more of konq, kio and
-  kio_sftp are compiled with the objprelink patches. None of the other
-  kioslaves do this for me, but it also happened when I recompiled kio_sftp
-  without the preloading, so I'm unsure whether it's a kio_sftp or kio or
-  konq bug. Will investigate some more. (Rob)
-
-COMPLETED
-=========
-
-- Orphaned ssh processes are bad. Shame on me. - Done 
-  Use SIGKILL to kill the ssh process. The ssh client seems to catch 
-  SIGTERM from its parent and ignore them.
-
-- Continuing partial upload - doesn't create .part file.d
-  fixed I think, but I am unable to test resume. kio denies my resume request - Done
-  
-- When typing sftp url into konqi, konqi tries to connect before we finish
-  typing url. Konqi is trying to do directory completion, but we don't 
-  want this when connecting to a remote server the first time. kio_ftp
-  doesn't do this...why? - Done
-  
-- When a connection gets canceled we are leaving ssh processes behind - Done
-
-- Notify the user when a new host key is received. - Done
-
-- Warn the user when the host key changes. - Done
-
-- Add support for other versions of OpenSSH and SSH. - Done
-
-- Store passwords per user/host pair, not per connection
-  (multiple users per host work now, but when switching views one has to
-   re-enter the login info every single time) - Done! This was a problem with 
-   caching in the ioslave base class and has been fixed.
-
-- Do not move items to trash when deleting (probably a generic kio_slave
-  problem, though, makes no sense to download everything you want to delete)
-  - Done! Fixing in konqueror
-
-- Support for different ports (sftp://user@host:port), this can be done by
-  adding the argument -oPort=7022 (or whatever port) to sftp, could not get
-  it to work properly though - Done
+  Improve keyboard interactive authentication
+  Improve password dialog for passphrase
+  Support for statvfs with libssh 0.4
Index: runtime/kioslave/sftp/CMakeLists.txt
===================================================================
--- runtime/kioslave/sftp/CMakeLists.txt	(revision 1026868)
+++ runtime/kioslave/sftp/CMakeLists.txt	(working copy)
@@ -1,20 +1,13 @@
-add_subdirectory(tests)
-
 ########### next target ###############
 
-set(kio_sftp_PART_SRCS 
-   process.cpp 
-   atomicio.cpp 
-   kio_sftp.cpp 
-   sftpfileattr.cpp 
-   ksshprocess.cpp )
+set(kio_sftp_PART_SRCS
+   kio_sftp.cpp
+)
 
+include_directories(${LIBSSH_INCLUDE_DIRS})
 
 kde4_add_plugin(kio_sftp ${kio_sftp_PART_SRCS})
-target_link_libraries(kio_sftp ${KDE4_KIO_LIBS} )
-if(NOT WIN32)
-    target_link_libraries(kio_sftp ${KDE4_KPTY_LIBS})
-endif(NOT WIN32)
+target_link_libraries(kio_sftp ${KDE4_KIO_LIBS} ${LIBSSH_LIBRARIES})
 
 install(TARGETS kio_sftp  DESTINATION ${PLUGIN_INSTALL_DIR} )
 
Index: runtime/kioslave/CMakeLists.txt
===================================================================
--- runtime/kioslave/CMakeLists.txt	(revision 1026868)
+++ runtime/kioslave/CMakeLists.txt	(working copy)
@@ -7,6 +7,9 @@
 macro_log_feature(SAMBA_FOUND "Samba" "the SMB client library, a version with smbc_set_context() and smbc_option_set()" "http://www.samba.org" FALSE "" "Needed to build the SMB kioslave")
 endif(NOT WIN32)
 
+macro_optional_find_package(LibSSH 0.3.4)
+macro_log_feature(LIBSSH_FOUND "libssh" "the SSH library with SFTP support" "http://www.libssh.org/" FALSE "" "Needed to build the SFTP kioslave")
+
 add_subdirectory( about )
 add_subdirectory( bookmarks )
 add_subdirectory( cgi )
@@ -21,18 +24,22 @@
 endif(NOT WIN32)
 add_subdirectory( remote )
 add_subdirectory( desktop )
-add_subdirectory( sftp )
 add_subdirectory( fish )
 add_subdirectory( thumbnail )
 add_subdirectory( docfilter )
+# msvc doesn't compile
+if (LIBSSH_FOUND AND NOT MSVC)
+  add_subdirectory(sftp)
+endif (LIBSSH_FOUND AND NOT MSVC)
 
 if(NOT WIN32)
    add_subdirectory( floppy )
    add_subdirectory( finger )
    add_subdirectory( man )
    add_subdirectory( nfs )  
+endif(NOT WIN32)
 
-   if(SAMBA_FOUND)
-      add_subdirectory(smb)
-   endif(SAMBA_FOUND)
-endif(NOT WIN32)
+if(SAMBA_FOUND OR WIN32)
+    add_subdirectory(smb)
+endif(SAMBA_FOUND OR WIN32)
+
